Graphics3D 640,480,16,2
SetBuffer BackBuffer()

Global cam=CreateCamera()
li=CreateLight(1,cam)
LightRange li,10000
LightColor li,255,255,255
PositionEntity cam,0,0,0
s=LoadMesh("FIGHTER.3Ds")

HideEntity s

t=LoadTexture("wall_00.jpg")
ScaleTexture t,.1,.1

k=B3DPlanarUVMapXYZ(s,1,1)
EntityTexture k,t

While Not KeyHit(1)

mouselook(cam)
keyControl(cam)
UpdateWorld
RenderWorld

;Color 255,255,255
;Text 10,10,tt
Flip
Wend
End


Function mouselook(ent)

	mxspd#=MouseXSpeed()*0.25
	myspd#=MouseYSpeed()*0.25

	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2	
	
	campitch#=EntityPitch(ent)+myspd#
	
	If campitch#<-85 Then campitch#=-85
	If campitch#>85 Then campitch#=85

	RotateEntity ent,campitch#,EntityYaw(ent)-mxspd#,EntityRoll(ent)
End Function

Function KeyControl(ent,mov#=1,Mode=1)

If Mode=1
If KeyDown(17) MoveEntity ent,0,0,mov
If KeyDown(31) MoveEntity ent,0,0,-mov
If KeyDown(32) MoveEntity ent,mov,0,0
If KeyDown(30) MoveEntity ent,-mov,0,0
ElseIf Mode=3
If KeyDown(200) MoveEntity ent,0,0,1
If KeyDown(208) MoveEntity ent,0,0,-1
If KeyDown(205) MoveEntity ent,1,0,0
If KeyDown(203) MoveEntity ent,-1,0,0
If KeyDown(17) MoveEntity ent,0,0,mov
If KeyDown(31) MoveEntity ent,0,0,-mov
If KeyDown(32) MoveEntity ent,mov,0,0
If KeyDown(30) MoveEntity ent,-mov,0,0
If MouseDown(1) MoveEntity ent,0,0,mov
If MouseDown(2) MoveEntity ent,0,0,-mov
ElseIf Mode=2
If KeyDown(200) MoveEntity ent,0,0,1
If KeyDown(208) MoveEntity ent,0,0,-1
If KeyDown(205) MoveEntity ent,1,0,0
If KeyDown(203) MoveEntity ent,-1,0,0
EndIf
End Function

Function B3DPlanarUVMapXZ(surf1,SetU#=1,SetV#=1) ;TOP



  ;MR 06.01.2003

	; Map all vertices from XZ plane
	; with vertex coordinates
For i2=1 To CountSurfaces(surf1)
surf=GetSurface(surf1,i2)

	Local	cv = CountVertices(surf)-1
  If cv<0 Then Return 0

	Local minu# = 3.4*10^38	
	Local maxu# = -3.4*10^38
	Local minv# = 3.4*10^38
	Local maxv# = -3.4*10^38

  Local coordset=0

  For i = 0 To cv
	 u# = VertexX(surf,i)
	 v# = VertexZ(surf,i)
	 If u<minu Then minu = u
	 If u>maxu Then maxu = u
	 If v<minv Then minv = v
	 If v>maxv Then maxv = v
	 VertexTexCoords surf,i,u,v,1.0,coordset
	Next
	
	; Scale all uv coordinates to be between
	; 0.0 and 1.0
	uscale# = Abs(maxu-minu)/setu
	vscale# = Abs(maxv-minv)/setv
	If uscale=0.0 Then uscale=1.0
	If vscale=0.0 Then vscale=1.0
			
	For i = 0 To cv
	 u# = (VertexU(surf,i,coordset)+minu)/uscale
	 v# = (VertexV(surf,i,coordset)+minv)/vscale
	 VertexTexCoords surf,i,u,-v,1.0,coordset      ;<- Is OK :-)
	Next

  Next

End Function

Function B3DPlanarUVMapXY(surf1,SetU#=1,SetV#=1) ;FRONT

  ;MR 06.01.2003

	; Map all vertices from XZ plane
	; with vertex coordinates

 For i2=1 To CountSurfaces(surf1)
surf=GetSurface(surf1,i2)
	cv = CountVertices(surf)-1
  
	Local minu# = 3.4*10^38	
	Local maxu# = -3.4*10^38
	Local minv# = 3.4*10^38
	Local maxv# = -3.4*10^38

  Local coordset=0

  For i = 0 To cv
	 u# = VertexX(surf,i)
	 v# = VertexY(surf,i)
	 If u<minu Then minu = u
	 If u>maxu Then maxu = u
	 If v<minv Then minv = v
	 If v>maxv Then maxv = v
	 VertexTexCoords surf,i,u,v,1.0,coordset
	Next
	
	; Scale all uv coordinates to be between
	; 0.0 and 1.0
	uscale# = Abs(maxu-minu)/setu
	vscale# = Abs(maxv-minv)/setv
	If uscale=0.0 Then uscale=1.0
	If vscale=0.0 Then vscale=1.0
			
	For i = 0 To cv
	 u# = (VertexU(surf,i,coordset)+minu)/uscale
	 v# = (VertexV(surf,i,coordset)+minv)/vscale
	 VertexTexCoords surf,i,u,-v,1.0,coordset     ;<- Is OK :-)
	Next

  Next

End Function

Function TreugExtract(s)
mymesh=CreateMesh()
mysurf=CreateSurface(Mymesh)

;For i= 1 To CountSurfaces(s)
;FindSurface(mesh,i)

KolvoSurf=CountSurfaces(S)
For i=1 To KolvoSurf
	worksurf=GetSurface(s,i)
	KolvoTreug=CountTriangles(workSurf)
	For j=0 To kolvotreug-1
		v1=TriangleVertex(worksurf,j,0)
		v2=TriangleVertex(worksurf,j,1)
		v3=TriangleVertex(worksurf,j,2)
		
		VV1=AddVertex(mysurf, VertexX(worksurf,v1), VertexY(worksurf,v1), VertexZ(worksurf,v1), VertexU(worksurf,v1),VertexV(worksurf,v1))
		VV2=AddVertex(mysurf, VertexX(worksurf,v2), VertexY(worksurf,v2), VertexZ(worksurf,v2), VertexU(worksurf,v2),VertexV(worksurf,v2))
		VV3=AddVertex(mysurf, VertexX(worksurf,v3), VertexY(worksurf,v3), VertexZ(worksurf,v3), VertexU(worksurf,v3),VertexV(worksurf,v3))
		AddTriangle(mysurf,VV1,VV2,VV3)
		AddTriangle(mysurf,VV2,VV1,VV3)
	Next
Next
UpdateNormals(mymesh)
Return Mymesh
End Function


Function B3DPlanarUVMapYZ(surf1,SetU#=1,SetV#=1) ;SIDE
; Map all vertices from XZ plane
; with vertex coordinates

  For i2=1 To CountSurfaces(surf1)
surf=GetSurface(surf1,i2)
cv = CountVertices(surf)-1

	Local minu# = 3.4*10^38
	Local maxu# = -3.4*10^38
	Local minv# = 3.4*10^38
	Local maxv# = -3.4*10^38

  Local coordset=0

  ;Find Min and Max

  For i = 0 To cv
	 u# = VertexY(surf,i)
	 v# = VertexZ(surf,i)
	 If u<minu Then minu = u
	 If u>maxu Then maxu = u
	 If v<minv Then minv = v
	 If v>maxv Then maxv = v
	 VertexTexCoords surf,i,u,v,1.0,coordset
	Next
	
	; Scale all uv coordinates to be between
	; 0.0 and 1.0
	uscale# = Abs(maxu-minu)/setu
	vscale# = Abs(maxv-minv)/setv
	If uscale=0.0 Then uscale=1.0
	If vscale=0.0 Then vscale=1.0
			
	For i = 0 To cv
	 u# = (VertexU(surf,i,coordset)+minu)/uscale
	 v# = (VertexV(surf,i,coordset)+minv)/vscale
	 VertexTexCoords surf,i,-v,-u,1.0,coordset    ;<- Is OK :-)
Next
 Next
End Function
Function B3DPlanarUVMapXYZ(workSurf1,SetU#=1,SetV#=1) ;TOP

Mymesh=CreateMesh()
mysurf=CreateSurface(Mymesh)

Xmesh=CreateMesh()
Xsurface=CreateSurface(Xmesh)
ymesh=CreateMesh()
Ysurface=CreateSurface(Ymesh)
zmesh=CreateMesh()
zsurface=CreateSurface(Zmesh)

KolvoSurf=CountSurfaces(workSurf1)
For i=1 To KolvoSurf
	worksurf=GetSurface(workSurf1,i)
	KolvoTreug=CountTriangles(workSurf)
	For j=0 To kolvotreug-1
		v1=TriangleVertex(worksurf,j,0)
		v2=TriangleVertex(worksurf,j,1)
		v3=TriangleVertex(worksurf,j,2)

		X1#=VertexX(worksurf,v1)
		X2#=VertexX(worksurf,v2)
		X3#=VertexX(worksurf,v3)
		Y1#=VertexY(worksurf,v1)
		Y2#=VertexY(worksurf,v2)
		Y3#=VertexY(worksurf,v3)
		Z1#=VertexZ(worksurf,v1)
		Z2#=VertexZ(worksurf,v2)
		Z3#=VertexZ(worksurf,v3)

		XMIN#=X1
		If X2<XMIN Then XMIN=X2
		If X3<XMIN Then XMIN=X3
		XMAX#=X1
		If X2>XMAX Then XMAX=X2
		If X3>XMAX Then XMAX=X3

		XRAZN#=xmax-xmin

		YMIN#=Y1
		If YMIN>Y2 Then YMIN=Y2
		If YMIN>Y3 Then YMIN=Y3
		YMAX#=Y1
		If YMAX<Y2 Then YMAX=Y2
		If YMAX<Y3 Then YMAX=Y3

		YRAZN#=ymax-ymin

		ZMIN#=Z1
		If ZMIN>Z2 Then ZMIN=Z2
		If ZMIN>Z3 Then ZMIN=Z3

		ZMAX#=Z1
		If ZMAX<Z2 Then ZMAX=Z2
		If ZMAX<Z3 Then ZMAX=Z3

		ZRAZN#=ZMAX-ZMIN
		xrazn=Abs(xrazn)
		yrazn=Abs(yrazn)
		zrazn=Abs(zrazn)
method=0

A#=Y2*Z3-Y2*Z1-Y1*Z3-Y3*Z2+Y3*Z1+Y1*Z2
B#=Z2*X3-Z2*X1-Z1*X3-Z3*X2+Z3*X1+Z1*X2
C#=X2*Y3-X2*Y1-X1*Y3-X3*Y2+x3*y1+x1*Y2
D#=-(x1*y2*z3-x1*y3*z2+y1*z2*x3-y1*z3*x2+z1*x2*y3-z1*x3*y2); if d>0 then cos(-) 
If Sqr(A*A+B*B+C*C)=0 Then
alpha#=44
beta#=43
gamma#=44
Else
If d<0 Then
;alpha#=(A/Sqr(A*A+B*B+C*C))
;Beta#=(B/Sqr(A*A+B*B+C*C))
;Gamma#=(C/Sqr(A*A+B*B+C*C))
alpha#=Abs(ACos(A/Sqr(A*A+B*B+C*C)))
Beta#=Abs(ACos(B/Sqr(A*A+B*B+C*C)))
Gamma#=Abs(ACos(C/Sqr(A*A+B*B+C*C)))
Else
;alpha#=(-A/Sqr(A*A+B*B+C*C))
;Beta#=(-B/Sqr(A*A+B*B+C*C))
;Gamma#=(-C/Sqr(A*A+B*B+C*C))
alpha#=Abs(ACos(-A/Sqr(A*A+B*B+C*C)))
Beta#=Abs(ACos(-B/Sqr(A*A+B*B+C*C)))
Gamma#=Abs(ACos(-C/Sqr(A*A+B*B+C*C)))

End If
End If

;If (alpha>beta And alpha>gamma) Then method=1;yz
;If (beta>alpha And beta>gamma )  Then method=2;xz
;If (gamma>alpha And gamma>beta) Then method=3;yx

;If alpha=beta And alpha=gamma Then method=1
;If alpha=gamma And alpha<>beta Then method=1


If (beta=>alpha And beta=>gamma And beta=>135)  Then method=2;xz
If (gamma=>alpha And gamma=>beta And gamma=>135) Then method=3;yx
If (alpha>beta And alpha=>gamma And alpha=>135) Then method=1;yz


If  (beta<=alpha And beta<=gamma And beta<=45)  Then method=2;xz
If  (gamma<=alpha And gamma<=beta And gamma<=45) Then method=3;yx
If  (alpha<=beta And alpha<=gamma And alpha<=45) Then method=1;yz

If method=0 Then method=2

If method=1 Then
        VV1=AddVertex(Xsurface, VertexX(worksurf,v1), VertexY(worksurf,v1), VertexZ(worksurf,v1), VertexU(worksurf,v1),VertexV(worksurf,v1))
		VV2=AddVertex(Xsurface, VertexX(worksurf,v2), VertexY(worksurf,v2), VertexZ(worksurf,v2), VertexU(worksurf,v2),VertexV(worksurf,v2))
		VV3=AddVertex(Xsurface, VertexX(worksurf,v3), VertexY(worksurf,v3), VertexZ(worksurf,v3), VertexU(worksurf,v3),VertexV(worksurf,v3))
		AddTriangle(Xsurface,VV1,VV2,VV3)
End If

If method=2 Then
        VV1=AddVertex(Ysurface, VertexX(worksurf,v1), VertexY(worksurf,v1), VertexZ(worksurf,v1), VertexU(worksurf,v1),VertexV(worksurf,v1))
		VV2=AddVertex(Ysurface, VertexX(worksurf,v2), VertexY(worksurf,v2), VertexZ(worksurf,v2), VertexU(worksurf,v2),VertexV(worksurf,v2))
		VV3=AddVertex(Ysurface, VertexX(worksurf,v3), VertexY(worksurf,v3), VertexZ(worksurf,v3), VertexU(worksurf,v3),VertexV(worksurf,v3))
		AddTriangle(Ysurface,VV1,VV2,VV3)
End If

If method=3 Then
      VV1=AddVertex(Zsurface, VertexX(worksurf,v1), VertexY(worksurf,v1), VertexZ(worksurf,v1), VertexU(worksurf,v1),VertexV(worksurf,v1))
		VV2=AddVertex(Zsurface, VertexX(worksurf,v2), VertexY(worksurf,v2), VertexZ(worksurf,v2), VertexU(worksurf,v2),VertexV(worksurf,v2))
		VV3=AddVertex(Zsurface, VertexX(worksurf,v3), VertexY(worksurf,v3), VertexZ(worksurf,v3), VertexU(worksurf,v3),VertexV(worksurf,v3))
		AddTriangle(Zsurface,VV1,VV2,VV3)
End If


	Next
Next
B3DPlanarUVMapYZ(Xmesh,SetU#=1,SetV#=1)
B3DPlanarUVMapXZ(Ymesh,SetU#=1,SetV#=1)
B3DPlanarUVMapXY(Zmesh,SetU#=1,SetV#=1)

KolvoSurf=CountSurfaces(Xmesh)
For i=1 To KolvoSurf
	Xwork=GetSurface(Xmesh,i)
	KolvoTreug=CountTriangles(Xwork)
	For j=0 To kolvotreug-1
		v1=TriangleVertex(Xwork,j,0)
		v2=TriangleVertex(Xwork,j,1)
		v3=TriangleVertex(Xwork,j,2)
		
		VV1=AddVertex(mysurf, VertexX(Xwork,v1), VertexY(Xwork,v1), VertexZ(Xwork,v1), VertexU(Xwork,v1),VertexV(Xwork,v1))
		VV2=AddVertex(mysurf, VertexX(Xwork,v2), VertexY(Xwork,v2), VertexZ(Xwork,v2), VertexU(Xwork,v2),VertexV(Xwork,v2))
		VV3=AddVertex(mysurf, VertexX(Xwork,v3), VertexY(Xwork,v3), VertexZ(Xwork,v3), VertexU(Xwork,v3),VertexV(Xwork,v3))
		AddTriangle(mysurf,VV1,VV2,VV3)
		;AddTriangle(mysurf,VV2,VV1,VV3)
	Next
Next


KolvoSurf=CountSurfaces(Ymesh)
For i=1 To KolvoSurf
	Ywork=GetSurface(Ymesh,i)
	KolvoTreug=CountTriangles(Ywork)
	For j=0 To kolvotreug-1
		v1=TriangleVertex(Ywork,j,0)
		v2=TriangleVertex(Ywork,j,1)
		v3=TriangleVertex(Ywork,j,2)
		
		VV1=AddVertex(mysurf, VertexX(Ywork,v1), VertexY(Ywork,v1), VertexZ(Ywork,v1), VertexU(Ywork,v1),VertexV(Ywork,v1))
		VV2=AddVertex(mysurf, VertexX(Ywork,v2), VertexY(Ywork,v2), VertexZ(Ywork,v2), VertexU(Ywork,v2),VertexV(Ywork,v2))
		VV3=AddVertex(mysurf, VertexX(Ywork,v3), VertexY(Ywork,v3), VertexZ(Ywork,v3), VertexU(Ywork,v3),VertexV(Ywork,v3))
		AddTriangle(mysurf,VV1,VV2,VV3)
		;AddTriangle(mysurf,VV2,VV1,VV3)
	Next
Next

KolvoSurf=CountSurfaces(Zmesh)
For i=1 To KolvoSurf
	Zwork=GetSurface(Zmesh,i)
	KolvoTreug=CountTriangles(Zwork)
	For j=0 To kolvotreug-1
		v1=TriangleVertex(Zwork,j,0)
		v2=TriangleVertex(Zwork,j,1)
		v3=TriangleVertex(Zwork,j,2)
		
		VV1=AddVertex(mysurf, VertexX(Zwork,v1), VertexY(Zwork,v1), VertexZ(Zwork,v1), VertexU(Zwork,v1),VertexV(Zwork,v1))
		VV2=AddVertex(mysurf, VertexX(Zwork,v2), VertexY(Zwork,v2), VertexZ(Zwork,v2), VertexU(Zwork,v2),VertexV(Zwork,v2))
		VV3=AddVertex(mysurf, VertexX(Zwork,v3), VertexY(Zwork,v3), VertexZ(Zwork,v3), VertexU(Zwork,v3),VertexV(Zwork,v3))
		AddTriangle(mysurf,VV1,VV2,VV3)
		;AddTriangle(mysurf,VV2,VV1,VV3)
	Next
Next
FreeEntity Xmesh
FreeEntity Ymesh
FreeEntity Zmesh
UpdateNormals(mymesh)
Return mymesh
End Function
